Lattice Grid Buy a licence

demo D203

How concentrated is it? in React

A Lorenz curve, the picture a Gini number is read off

type: 'lorenz', y

This draws a Lorenz curve, the picture a Gini number is read from, showing how concentrated a column's values are. It makes inequality or concentration in a dataset visible, so 'a few rows hold most of the total' becomes a shape you can see.

Building…
Loading a live grid…

This is the React version. The grid mounts through the createLatticeGrid adapter, which takes its configuration as ordinary props and hands back the live grid through a ref. The grid below is the same one every other tab runs.

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/lattice-grid.esm.min.js';
  import { createLatticeReact } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/react.esm.min.js';
  import { createChart } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.71.0/modules/charts.esm.min.js';

  const { LatticeGrid, LatticeChart } = createLatticeReact({ React, createGrid, createChart });

  const columns = [
    { field: 'symbol', title: 'Symbol' },
    { field: 'desk', title: 'Desk', filter: { type: 'set' } },
    { field: 'region', title: 'Region', filter: { type: 'set' } },
    { field: 'price', title: 'Price', type: 'number', format: { decimals: 4 } },
    { field: 'bid', title: 'Bid', type: 'number', format: { decimals: 4 } },
    { field: 'volume', title: 'Volume', type: 'number', format: { notation: 'compact' } },
    { field: 'notional', title: 'Notional', type: 'number', format: { style: 'currency', currency: 'USD' }, total: 'sum' },
  ];
  const rows = [/* trading book: symbol, desk, region, price, bid, volume, notional */];

  function App() {
    const [grid, setGrid] = React.useState(null);

    // A Lorenz curve reads y alone; the gap from the diagonal is the inequality.
    return (
      <>
        {grid && <LatticeChart grid={grid} type="lorenz" y="notional" title="Lorenz curve of notional" style={{ height: '340px' }} />}
        <LatticeGrid rowKey="id" columns={columns} rows={rows} onGridReady={setGrid} style={{ height: '340px', marginTop: '14px' }} />
      </>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Lattice Grid Buy a licence

demo D203

How concentrated is it? in Angular

A Lorenz curve, the picture a Gini number is read off

type: 'lorenz', y

This draws a Lorenz curve, the picture a Gini number is read from, showing how concentrated a column's values are. It makes inequality or concentration in a dataset visible, so 'a few rows hold most of the total' becomes a shape you can see.

Building…
Loading a live grid…

This is the Angular version. A standalone component takes the whole configuration through one config input, surfaces grid events as outputs, and exposes the live grid on a getter for anything the inputs do not cover.

The configuration

import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import { createChart } from '@toclocoinc/lattice-grid/modules/charts';
import { LatticeGridComponent, provideLattice } from '@toclocoinc/lattice-grid/angular';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div id="chart" style="height:340px"></div>' +
    '<lattice-grid [config]="grid" style="display:block;height:340px;margin-top:14px"></lattice-grid>',
})
export class AppComponent implements AfterViewInit {
  @ViewChild(LatticeGridComponent) gridRef!: LatticeGridComponent;

  grid = {
    rowKey: 'id',
    columns: [
      { field: 'symbol', title: 'Symbol' },
      { field: 'desk', title: 'Desk', filter: { type: 'set' } },
      { field: 'region', title: 'Region', filter: { type: 'set' } },
      { field: 'price', title: 'Price', type: 'number', format: { decimals: 4 } },
      { field: 'bid', title: 'Bid', type: 'number', format: { decimals: 4 } },
      { field: 'volume', title: 'Volume', type: 'number', format: { notation: 'compact' } },
      { field: 'notional', title: 'Notional', type: 'number', format: { style: 'currency', currency: 'USD' }, total: 'sum' },
    ],
    rows: [/* trading book: symbol, desk, region, price, bid, volume, notional */],
  };

  ngAfterViewInit() {
    // A Lorenz curve reads y alone; the gap from the diagonal is the inequality.
    createChart({ grid: this.gridRef.grid, container: '#chart', type: 'lorenz', y: 'notional', title: 'Lorenz curve of notional' });
  }
}

bootstrapApplication(AppComponent, {
  providers: [provideLattice({ createGrid })],
});